/*
RefreshWallpaper - Refresh Windows wallpaper utility.

Copyright (C) Nikolay Raspopov, 20012.
http://www.cherubicsoft.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "stdafx.h"

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpCmdLine, int /*nCmdShow*/)
{
	// Usage
	if ( _tcsicmp( lpCmdLine, _T("/?") ) == 0 || _tcsicmp( lpCmdLine, _T("-?") ) == 0 ||
		 _tcsicmp( lpCmdLine, _T("/h") ) == 0 || _tcsicmp( lpCmdLine, _T("-h") ) == 0 )
	{
		TCHAR szHelp[ 1024 ] = {};
		LoadString( hInstance, IDS_OPTIONS_HELP, szHelp, 1024 );
		MessageBox( NULL, szHelp, _T("RefreshWallpaper"), MB_OK | MB_ICONINFORMATION );
		return 0;
	}

	// Get old wallpaper
	TCHAR szWallpaper[ 1024 ] = {};
	if ( ! SystemParametersInfo( SPI_GETDESKWALLPAPER, 1024, (LPVOID)szWallpaper, 0 ) )
		return 1;

	// Change to new one if defined
	if ( lpCmdLine && *lpCmdLine && GetFileAttributes( lpCmdLine ) != INVALID_FILE_ATTRIBUTES )
		_tcscpy_s( szWallpaper, lpCmdLine );

	// Set wallpaper
	if ( ! SystemParametersInfo( SPI_SETDESKWALLPAPER, 0, (LPVOID)szWallpaper, SPIF_SENDCHANGE | SPIF_UPDATEINIFILE ) )
		return 1;

	return 0;
}
